function x = qr_solve(A, b)
	% x = qr_solve(A, b)
	% Risolve il sistema lineare A * x = b con fattorizzazione QR
	% Il fattore Q non viene costruito esplicitamente

	n = size(A, 1);

	for i = 1:n-1
		[beta, v] = householder_vector(A(i:end, i));
		% Riflettore di Householder H = I - b * v * v'/(v'*v): 
		A(i:end, i:end) = A(i:end, i:end) - beta * v * (v' * A(i:end, i:end)); 
		b(i:end) = b(i:end) - beta * v * (v' * b(i:end)); 
	end
	
	% Ora A corrisponde al fattore triangolare superiore R della fattorizzazione QR: 
	x = sup_solve2(A, b);
end
